VERSION 5.00
Begin VB.Form FMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "AlphaBlend"
   ClientHeight    =   2715
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3240
   HasDC           =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2715
   ScaleWidth      =   3240
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.VScrollBar vsbBlend 
      Height          =   1980
      Left            =   2573
      TabIndex        =   2
      Top             =   367
      Width           =   255
   End
   Begin VB.PictureBox picSource 
      BackColor       =   &H00C0E0FF&
      BorderStyle     =   0  'Kein
      Height          =   1335
      Left            =   -600
      ScaleHeight     =   1335
      ScaleWidth      =   1335
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   2160
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.PictureBox picDest 
      Height          =   1980
      Left            =   413
      ScaleHeight     =   1920
      ScaleWidth      =   1920
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   367
      Width           =   1980
   End
End
Attribute VB_Name = "FMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function AlphaBlend Lib "msimg32.dll" ( _
    ByVal hdcDest As Long, _
    ByVal nXOriginDest As Long, _
    ByVal nYOriginDest As Long, _
    ByVal nWidthDest As Long, _
    ByVal nHeightDest As Long, _
    ByVal hdcSrc As Long, _
    ByVal nXOriginSrc As Long, _
    ByVal nYOriginSrc As Long, _
    ByVal nWidthSrc As Long, _
    ByVal nHeightSrc As Long, _
    ByVal BlendFunction As Long _
) As Long

Private Type BlendFunction
    BlendOp As Byte
    BlendFlags As Byte
    SourceConstantAlpha As Byte
    AlphaFormat As Byte
End Type

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

Private Sub Form_Load()
    On Error GoTo ErrorHandler
    Dim strAppPath As String
    strAppPath = App.Path
    If Right$(strAppPath, 1) <> "\" Then
        strAppPath = strAppPath & "\"
    End If
    With Me.picSource
        Set .Picture = LoadPicture(strAppPath & "win2k.bmp")
        .ScaleMode = vbPixels
        .AutoRedraw = True
    End With
    With Me.picDest
        Set .Picture = LoadPicture(strAppPath & "sky.bmp")
        .ScaleMode = vbPixels
        .AutoRedraw = True
    End With
    With Me.vsbBlend
        .Min = 0
        .Max = 255
        .Value = 256 / 2
    End With
    Exit Sub
ErrorHandler:
    Call MsgBox("Error " & CStr(Err.Number) & ": " & Err.Description & ".", vbExclamation, App.Title)
    Call Unload(Me)
End Sub

Private Sub vsbBlend_Change()
    Dim bfBlend As BlendFunction
    Dim lngBlend As Long
    Dim lngLeft As Long, lngTop As Long
    lngLeft = (Me.picDest.ScaleWidth - Me.picSource.ScaleWidth) * 0.5
    lngTop = (Me.picDest.ScaleHeight - Me.picSource.ScaleHeight) * 0.5
    bfBlend.SourceConstantAlpha = 255 - Me.vsbBlend.Value
    Call CopyMemory(lngBlend, bfBlend, 4&)
    Call Me.picDest.Cls
    
    ' Fade DCs.
    Call AlphaBlend(Me.picDest.hDC, lngLeft, lngTop, Me.picSource.ScaleWidth, Me.picSource.ScaleHeight, Me.picSource.hDC, 0&, 0&, Me.picSource.ScaleWidth, Me.picSource.ScaleHeight, lngBlend)
    Call Me.picDest.Refresh
End Sub

Private Sub vsbBlend_Scroll()
    Call vsbBlend_Change
End Sub
